org.bouncycastle.crypto.macs

## Class I2PHMac

- java.lang.Object
- - org.bouncycastle.crypto.macs.I2PHMac

- All Implemented Interfaces:
    Mac

      public class I2PHMac
      extends Object
      implements Mac

  HMAC implementation based on RFC2104 H(K XOR opad, H(K XOR ipad, text)) modified by jrandom to use the session key byte array directly and to cache a frequently used buffer (called on doFinal). changes released into the public domain in 2005. This is renamed from HMac because the constructor HMac(digest, sz) does not exist in the standard bouncycastle library, thus it conflicts in JVMs that contain the standard library (Android).

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `I2PHMac(Digest digest)`
    `I2PHMac(Digest digest, int sz)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `doFinal(byte[] out, int outOff)` Compute the final statge of the MAC writing the output to the out parameter.
    `String` | `getAlgorithmName()` Return the name of the algorithm the MAC implements.
    `int` | `getMacSize()` Return the block size for this cipher (in bytes).
    `Digest` | `getUnderlyingDigest()`
    `void` | `init(byte[] key)` Initialise the MAC.
    `void` | `reset()` Reset the mac generator.
    `void` | `update(byte in)` add a single byte to the mac for processing.
    `void` | `update(byte[] in, int inOff, int len)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### I2PHMac

          public I2PHMac(Digest digest)

    - #### I2PHMac

          public I2PHMac(Digest digest,
                 int sz)

      Parameters:
        `sz` - override the digest's size SEE NOTES in HMACGenerator about why this isn't compatible with standard HmacMD5

  - ### Method Detail

    - #### getAlgorithmName

          public String getAlgorithmName()

      Description copied from interface: `Mac`
      Return the name of the algorithm the MAC implements.
      Specified by:
        `getAlgorithmName` in interface `Mac`
      Returns:
        the name of the algorithm the MAC implements.

    - #### getUnderlyingDigest

          public Digest getUnderlyingDigest()

    - #### init

          public void init(byte[] key)

      Description copied from interface: `Mac`
      Initialise the MAC.
      Specified by:
        `init` in interface `Mac`
      Parameters:
        `key` - the key required by the MAC.

    - #### getMacSize

          public int getMacSize()

      Description copied from interface: `Mac`
      Return the block size for this cipher (in bytes).
      Specified by:
        `getMacSize` in interface `Mac`
      Returns:
        the block size for this cipher in bytes.

    - #### update

          public void update(byte in)

      Description copied from interface: `Mac`
      add a single byte to the mac for processing.
      Specified by:
        `update` in interface `Mac`
      Parameters:
        `in` - the byte to be processed.

    - #### update

          public void update(byte[] in,
                    int inOff,
                    int len)

      Specified by:
        `update` in interface `Mac`
      Parameters:
        `in` - the array containing the input.
        `inOff` - the index in the array the data begins at.
        `len` - the length of the input starting at inOff.

    - #### doFinal

          public int doFinal(byte[] out,
                    int outOff)

      Description copied from interface: `Mac`
      Compute the final statge of the MAC writing the output to the out parameter.

      doFinal leaves the MAC in the same state it was after the last init.

      Specified by:
        `doFinal` in interface `Mac`
      Parameters:
        `out` - the array the MAC is to be output to.
        `outOff` - the offset into the out buffer the output is to start at.

    - #### reset

          public void reset()

      Reset the mac generator.
      Specified by:
        `reset` in interface `Mac`